'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

exports.default = function (_ref) {
  var t = _ref.types;

  var routeFnIdentifier = void 0;
  return {
    visitor: {
      ImportDeclaration: function ImportDeclaration(path, state) {
        var isRouteImport = path.node.source.value === _utils.ROUTE_IMPORT_VALUE;
        var importSpecifier = path.node.specifiers[0];
        var isDefaultImport = t.isImportDefaultSpecifier(importSpecifier);

        if (isRouteImport && isDefaultImport) {
          var imports = state.file.metadata.modules.imports;

          routeFnIdentifier = importSpecifier.local.name;
          path.remove();
          state.file.metadata.modules.imports = imports.filter(function (imprt) {
            return imprt.source !== _utils.ROUTE_IMPORT_VALUE;
          });
        }
      },
      CallExpression: function CallExpression(path, state) {
        var node = path.node;

        var routeBinding = path.scope.bindings[routeFnIdentifier];
        var isRouteCallee = node.callee.name === routeFnIdentifier;
        var isModule = routeBinding ? routeBinding.kind === 'module' : null;

        if (isRouteCallee && isModule) {
          var _node$arguments = _slicedToArray(node.arguments, 2);

          var nameArg = _node$arguments[0];
          var pathArg = _node$arguments[1];

          var isNameString = t.isStringLiteral(nameArg);
          var isPathString = t.isStringLiteral(pathArg);
          var parentArguments = path.parent.arguments;

          if (node.arguments.length < 2) {
            (0, _utils.logRouteFewArguments)(routeFnIdentifier, node, state);
            return;
          } else if (node.arguments.length > 2) {
            (0, _utils.logRouteManyArguments)(routeFnIdentifier, node, state);
          } else if (!isNameString || !isPathString) {
            (0, _utils.logRouteStringArguments)(routeFnIdentifier, node, state);
            return;
          }

          if (parentArguments) {
            var parentCallee = path.parent.callee;
            var isCalleeRoute = (0, _utils.isRouteParentCallee)(routeFnIdentifier, path);
            var isFewArguments = isCalleeRoute ? parentArguments.length < 1 : false;
            var isManyArguments = isCalleeRoute ? parentArguments.length > 1 : false;

            if (isFewArguments) {
              (0, _utils.logRouteParentFewArguments)(routeFnIdentifier, parentCallee, state);
            } else if (isManyArguments) {
              (0, _utils.logRouteParentManyArguments)(routeFnIdentifier, parentCallee, state);
              return;
            }

            if (isCalleeRoute) {
              path.parentPath.replaceWith(parentArguments[0]);
            }
          }

          path.remove();
          state.file.metadata.vtexRender = {
            route: {
              name: nameArg.value,
              path: pathArg.value
            }
          };
        }
      }
    }
  };
};

var _utils = require('./utils');